package org.jcg.zheng.demo.async;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import org.jcg.zheng.demo.async.data.DataUtils;
import org.jcg.zheng.demo.async.data.Order;
import org.jcg.zheng.demo.async.tasks.NotifyUserTask;
import org.jcg.zheng.demo.async.tasks.ProcessOrderTask;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ProcessOrders_BeforeCompletableFuture {

    final Logger logger = LoggerFactory.getLogger(this.getClass());

    public void processOrder(int orderCounts) {
        ExecutorService service = Executors.newFixedThreadPool(orderCounts);

        logger.info(DataUtils.THREAD_STARTS);
        for (int i = 0; i < orderCounts; i++) {
            Callable<Order> orderTask = new ProcessOrderTask(i);
            Future<Order> future = service.submit(orderTask);

            try {
                Order order = future.get();
                logger.info(DataUtils.MAIN_THREAD_RESUMES + " with results from async task ="
                        + order.toString());

                Callable<Order> emailTask = new NotifyUserTask(order);
                future = service.submit(emailTask);

                order = future.get();

                logger.info(DataUtils.MAIN_THREAD_RESUMES + " with results from async task ="
                        + order.toString());
            } catch (InterruptedException | ExecutionException e) {
            }
        }
    }

}
