package org.jcg.zheng.demo.async.data;

import java.util.concurrent.TimeUnit;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class DataUtils {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    public static final String MAIN_THREAD_RESUMES = "Main thread resumes after the async task is completed. ";

    public static final String THREAD_STARTS = "started. ";
    public static final String THREAD_COMPLETED = "completed. ";
    public static final String THREAD_ABORTED = "Aborted!";

    public Order sendEmail(Order order) {
        logger.info("sendEmail " + DataUtils.THREAD_STARTS);
        try {
            if (OrderStatus.PROCESSED.equals(order.getStatus())) {
                order.setDetail("sent an email-processed.");
                TimeUnit.SECONDS.sleep(5);
            } else {
                order.setDetail("send an email-error.");
                TimeUnit.SECONDS.sleep(2);
            }
            logger.info("sendEmail " + DataUtils.THREAD_COMPLETED);
        } catch (InterruptedException e) {
            logger.info("sendEmail " + DataUtils.THREAD_ABORTED);
        }
        return order;
    }

    public Order processOrder(Order order) {
        logger.info("processOrder " + DataUtils.THREAD_STARTS);
        try {
            TimeUnit.SECONDS.sleep(5);
            if (order.getOrderId().intValue() % 5 == 0) {
                order.setDetail("processOrder failed.");
                order.setStatus(OrderStatus.ERROR);
            } else {
                order.setDetail("processOrder succeed.");
                order.setStatus(OrderStatus.PROCESSED);
            }
            logger.info("processOrder " + DataUtils.THREAD_COMPLETED);
        } catch (InterruptedException e) {
            logger.info("processOrder " + DataUtils.THREAD_ABORTED);
        }
        return order;
    }
}
