package org.jcg.zheng.demo.async.data;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Order {
    final Logger logger = LoggerFactory.getLogger(this.getClass());

    private Integer orderId;
    private OrderStatus status;
    private String detail;

    public Integer getOrderId() {
        return orderId;
    }

    public void setOrderId(Integer orderId) {
        this.orderId = orderId;
    }

    public OrderStatus getStatus() {
        return status;
    }

    public void setStatus(OrderStatus status) {
        this.status = status;
    }

    public String getDetail() {
        return detail;
    }

    public void setDetail(String detail) {
        this.detail = detail;
    }

    public Order emailNotification() {
        this.setStatus(OrderStatus.NOTIFIED);
        (new DataUtils()).sendEmail(this);
        logger.info("emailNotification for " + this.orderId);
        return this;
    }

    public Order process() {
        logger.info("process for " + this.orderId);
        (new DataUtils()).processOrder(this);
        return this;
    }

    @Override
    public String toString() {
        return "Order [orderId=" + orderId + ", status=" + status + ", detail=" + detail + "]";
    }

}
