package org.jcg.zheng.demo.async.tasks;

import java.util.UUID;
import java.util.concurrent.Callable;
import java.util.concurrent.TimeUnit;

import org.jcg.zheng.demo.async.data.DataUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CallableTask implements Callable<String> {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Override
    public String call() throws Exception {
        logger.info(DataUtils.THREAD_STARTS);
        try {
            TimeUnit.SECONDS.sleep(5);
            logger.info(DataUtils.THREAD_COMPLETED);
            return UUID.randomUUID().toString();
        } catch (InterruptedException e) {
            logger.info(DataUtils.THREAD_ABORTED);
            return "ERROR";
        }
    }

}
