package org.jcg.zheng.demo.async.tasks;

import java.util.concurrent.Callable;

import org.jcg.zheng.demo.async.data.DataUtils;
import org.jcg.zheng.demo.async.data.Order;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class NotifyUserTask implements Callable<Order> {

    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    private Order order;

    public NotifyUserTask(Order order) {
        super();
        this.order = order;
    }

    @Override
    public Order call() throws Exception {
        logger.info(DataUtils.THREAD_STARTS);
        (new DataUtils()).sendEmail(order);
        logger.info(DataUtils.THREAD_COMPLETED);
        return order;
    }

}
