package org.jcg.zheng.demo.async.tasks;

import java.util.function.Supplier;

import org.jcg.zheng.demo.async.data.DataUtils;
import org.jcg.zheng.demo.async.data.Order;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SupplierOrderTask implements Supplier<Order> {

    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    private Integer orderId;

    public SupplierOrderTask(Integer orderId) {
        super();
        this.orderId = orderId;
    }

    @Override
    public Order get() {
        logger.info(DataUtils.THREAD_STARTS + " for " + orderId);
        Order order = new Order();
        order.setOrderId(orderId);
        return (new DataUtils()).processOrder(order);
    }
}
