package org.jcg.zheng.demo.async.tasks;

import java.util.Random;
import java.util.concurrent.TimeUnit;
import java.util.function.Supplier;

import org.jcg.zheng.demo.async.data.DataUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SupplierTask implements Supplier<Integer> {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Override
    public Integer get() {
        logger.info(DataUtils.THREAD_STARTS);
        try {
            TimeUnit.SECONDS.sleep(5);
            Random randon = new Random();
            logger.info(DataUtils.THREAD_COMPLETED);
            return randon.ints(1, 1000).findFirst().getAsInt();
        } catch (InterruptedException e) {
            logger.info(DataUtils.THREAD_ABORTED);
            return -1;
        }

    }
}
