package org.jcg.zheng.demo.async;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

import org.jcg.zheng.demo.async.tasks.ChainOperations_PrimitiveType;
import org.junit.Test;

public class ChainOperations_PrimitiveTypeTest extends TestBase {

    ChainOperations_PrimitiveType plDemo = new ChainOperations_PrimitiveType();

    @Test
    public void it_should_calculate_to_six() {
        CompletableFuture<Integer> future = new CompletableFuture<>();
        plDemo.mathFunctionDemo(future);
        boolean completed = future.complete(2);
        assertTrue(completed);
    }

    @Test
    public void exceed_timeout_limit() {
        CompletableFuture<Integer> future = new CompletableFuture<>();
        future.orTimeout(1, TimeUnit.NANOSECONDS);
        plDemo.mathFunctionDemo(future);
        boolean completed = future.complete(2);
        assertFalse(completed);
    }

    @Test
    public void complete_within_timeout_limit() {
        CompletableFuture<Integer> future = new CompletableFuture<>();
        future.completeOnTimeout(500, 3, TimeUnit.SECONDS);
        plDemo.mathFunctionDemo(future);
        boolean completed = future.complete(2);
        assertTrue(completed);
    }

}
