package org.jcg.zheng.demo.async;

import java.util.concurrent.TimeUnit;

import org.jcg.zheng.demo.async.data.DataUtils;
import org.junit.After;
import org.junit.Before;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TestBase {

    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    long allocatedMemoryBefore;
    long allocatedMemeoryAfter;
    protected long sleepInSeconds = 7;


    public TestBase() {
        super();
    }

    @Before
    public void setup() {
        allocatedMemoryBefore = getAllocatedMemory();
        logger.info(DataUtils.THREAD_STARTS);
    }

    long getAllocatedMemory() {
        long allocatedMemory = Runtime.getRuntime().totalMemory()
                - Runtime.getRuntime().freeMemory();
        return allocatedMemory;
    }

    @After
    public void clear() {
        allocatedMemeoryAfter = getAllocatedMemory();
        long memoryUsed = (allocatedMemeoryAfter - allocatedMemoryBefore) / 1000;
        logger.info(DataUtils.THREAD_COMPLETED + "Total memory used " + memoryUsed + "KB."
                + " Waiting for "
                + sleepInSeconds + " seconds");

        try {
            TimeUnit.SECONDS.sleep(sleepInSeconds);
        } catch (InterruptedException e) {
        }
    }

    protected void printNum(Integer d) {
        logger.info("printNum " + d.intValue());
    }

}